public class SchedulerApp implements Cloneable {
  protected TextStrategy  textStrategy;
  protected ThemaStrategy themaStrategy;
  public final void run()
  {
    // 略
    themaStrategy.drawThema();
    // 略
    textStrategy.drawText();
    // 略
  }
  public SchedulerApp( TextStrategy  textStrategy,
                       ThemaStrategy themaStrategy )
  {
    this.textStrategy  = textStrategy;
    this.themaStrategy = themaStrategy;
    // 略
  }
  public final void setThemaStrategy( ThemaStrategy themaStrategy )
  {
    this.themaStrategy = themaStrategy;
  }
  public Object clone() throws CloneNotSupportedException
  {
    SchedulerApp instance = (SchedulerApp) super.clone();
    instance.textStrategy  = (TextStrategy)textStrategy.clone();
    instance.themaStrategy = (ThemaStrategy)themaStrategy.clone();
    // 他にコピーすべきものもコピーする
    return instance;
  }
    // 他の詳細は略
}