// A社で作られた推敲クラス
class TextImprover {
  public void improveText( StringBuffer text, int flag )
  { /* 略 */ }
}

// B社で作られた推敲クラス
class TextChecker {
  public void 
  checkText( int flag1, int flag2, StringBuffer text )
  { /* 略 */ }
}

// テキストエディタ用の推敲インタフェイス
interface TextRefiner {
  public void refineText( StringBuffer text );
}

// A社製推敲クラス用のアダプタクラス
class TextRefinerA implements TextRefiner {
  private TextImprover ti = new TextImprover();
  public void refineText( StringBuffer text ) {
    ti.improveText( text, 0 );
  }
}

// B社製推敲クラス用のアダプタクラス
class TextRefinerB implements TextRefiner {
  private TextChecker tc = new TextChecker();
  public void refineText( StringBuffer text ) {
    tc.checkText( 0, 0, text );
  }
}

class TextDocument {
  private StringBuffer text = new StringBuffer();
  public void editText() {
    /* 略 */
    TextRefiner tr = new TextRefinerA();
    tr.refineText( text );
    /* 略 */
  }
}