#include <vector>
#include <list>
using namespace std;

// X^bNpC^tFCX
template <class T> class Stack {
  public :
    virtual void push( T & element ) = 0;
    virtual T pop( void ) = 0;
};

// xN^gX^bN
template <class T> class StackUsingVector
 : public Stack, public vector<T> {
  public :
    void push( T & element ) { 
      push_back( element );
    }
    T pop( void ) { 
      T temp = back(); pop_back(); return temp;
    }   
 };