package share;
import java.util.*;

public class FlyweightFactory {
  private TreeMap flyweights = new TreeMap();
  public final ConcreteFlyweight getFlyweight( String key ) {
      ConcreteFlyweight temp = (ConcreteFlyweight)flyweights.get( key );
      if( temp != null ) return temp;
      else {
        temp = new ConcreteFlyweight();
        if( temp != null ) flyweights.put( key, temp );
        return temp;
      }
    }
  public final UnsharedConcreteFlyweight getUnsharedFW( ) {
    return new UnsharedConcreteFlyweight();
  }
}