interface Expression {
  int interpret();
 }

class AddExpression implements Expression {
  private Expression left, right;
  public AddExpression( Expression left, Expression right ) 
  { this.left = left;  this.right = right; }
  public int interpret( ) { 
    return left.interpret() + right.interpret();
  }
}

class Number implements Expression {
  private int n;
  public Number( int n ) { this.n = n; }
  public int interpret( ) { return n; }
}

public class Interpreter {
  public static void main( String args[] ) {
    Number node4 = new Number( 1 ), node5 = new Number( 2 ), 
           node6 = new Number( 3 ), node7 = new Number( 4 );
    AddExpression node2 = new AddExpression( node4, node5 ),
                  node3 = new AddExpression( node6, node7 ),
                  node1 = new AddExpression( node2, node3 );
  System.out.println( node1.interpret() );
  }
}