package document;
import caretaker.*;

public class TextDocument { // 書類オブジェクト // Originatorに相当する
  private StringBuffer state = new StringBuffer(); // 内部状態
  private TextDocumentCaretaker caretaker  // 書類にCaretakerを持たせる
    = new TextDocumentCaretaker();
  public void createMemento() {
    caretaker.pushMemento( new TextDocumentMemento( state ) );
  }
  public void setMemento() {
    TextDocumentMemento m = caretaker.popMemento();
    if( m != null ) state = m.getState();
  }
  public StringBuffer getData() { return state; }
  public void setData( String str ) {
    state = new StringBuffer( str );
  }
  public void print() { System.out.println( state ); }
}