import java.util.Vector;

public abstract class Document {
  protected static Vector docList;
  protected abstract void DoGetParameter();
  protected abstract void DoConstructData();
  protected abstract void DoDisplay();

  public final void NewDocument() // finalに注意！
    {
      //手順(1)
      DoGetParameter();
      //手順(2)
      DoConstructData();
      //手順(3)
      docList.addElement( this );
      //手順(4)
      DoDisplay();
    }

  // 他の詳細は省略
}