class GUIDesign {
  public :
    // ``悷
    virtual void drawRect( void ) = 0;
    // 摜f[^`悷
    virtual void drawPicture( void ) = 0;
    // `悷
    virtual void drawText( void ) = 0;
};

class GUIPart {
  private :
    GUIDesign * gd;
  protected :
    void displayRect( void ) { gd->drawRect(); }
    void displayPict( void ) { gd->drawPicture(); }
    void displayText( void ) { gd->drawText(); }
    GUIPart( GUIDesign & d ) : gd( &d ) {}
    ~GUIPart( void ) { delete gd; }
};

class GUIDesigneforChildren : public GUIDesign {
  public :
     void drawRect( void ) { /*  */ }
     void drawPicture( void ) { /*  */ }
     void drawText( void ) { /*  */ }
};

class GUIDesigneforOld : public GUIDesign {
  public :
     void drawRect( void ) { /*  */ }
     void drawPicture( void ) { /*  */ }
     void drawText( void ) { /*  */ }
};

class GUIButton : public GUIPart {
  public :
    void display( void )
    { displayText(); displayRect(); } 
    GUIButton( GUIDesign & gd ) : GUIPart(gd) {}
};

class GUIIcon : public GUIPart {
  public :
    void display( void )
    { displayPict(); displayRect(); } 
    GUIIcon( GUIDesign & gd ) : GUIPart(gd) {}
};