interface GUIDesign {
    // 矩形を描画する
    void drawRect();
    // 画像データを描画する
    void drawPicture();
    // 文字列を描画する
    void drawText();
}

abstract class GUIPart {
  private GUIDesign gd;
  protected void displayRect() { gd.drawRect(); }
  protected void displayPict() { gd.drawPicture(); }
  protected void displayText() { gd.drawText(); }
  protected GUIPart( GUIDesign d ) { gd = d; }
}

class GUIDesigneforChildren implements GUIDesign {
  public void drawRect() { /* 略 */ }
  public void drawPicture() { /* 略 */ }
  public void drawText() { /* 略 */ }
}

class GUIDesigneforOld implements GUIDesign {
  public void drawRect() { /* 略 */ }
  public void drawPicture() { /* 略 */ }
  public void drawText() { /* 略 */ }
}

class GUIButton extends GUIPart {
  public void display()
  { displayText(); displayRect(); } 
  public GUIButton( GUIDesign gd ) { super(gd); }
}

class GUIIcon extends GUIPart {
  public void display()
  { displayPict(); displayRect(); } 
  public GUIIcon( GUIDesign gd ) { super(gd); }
}