import java.util.Vector;

// スタック用インタフェイス
interface Stack {
  void push( Object element );
  Object pop();
}

// ベクタを使ったスタック
class StackUsingVector 
 extends Vector implements Stack {
  public void push( Object element ) { 
    addElement( element );
  }
  public Object pop() { 
    Object temp = lastElement();
    removeElementAt( size() - 1 ); return temp;
  }   
}