class DrawTool;

// }``c[̑IԂ\ۃNX
class DTState {
  public :
    virtual void handleClick( DrawTool * dt, int x1, int y1 ) = 0;
    virtual void handleHelp( void ) = 0;
    virtual ~DTState( void ) {}
  protected :
    void changeDTState( DrawTool * dt, DTState * s );
};

// }``c[IԂ\̃NX(Singletonp^[gp)
class NonSelected : public DTState {
    static NonSelected * _instance;
    NonSelected( void ) {}
  public :
    static DTState * instance( void ) {
      if( _instance == 0 ) _instance = new NonSelected();
      return _instance;
    }
    void handleClick( DrawTool * dt, int x1, int y1 );
    void handleHelp( void ) {
      // SʓIȎɊւwvʂ\
    }
};
NonSelected * NonSelected::_instance = 0;

// ``c[IԂ\̃NX(Singletonp^[gp)
class RectToolSelected : public DTState {
    static RectToolSelected * _instance;
    RectToolSelected( void ) {}
  public :
    static DTState * instance( void ) {
      if( _instance == 0 ) _instance = new RectToolSelected();
      return _instance;
    }
    void handleClick( DrawTool * dt, int x1, int y1 );
    void handleHelp( void ) {
      // ``c[̎gwvʂ\
    }
};
RectToolSelected * RectToolSelected::_instance = 0;

// eLXg`c[IԂ\̃NX(Singletonp^[gp)
class TextToolSelected : public DTState {
    static TextToolSelected * _instance;
    TextToolSelected( void ) {}
  public :
    static DTState * instance( void ) {
      if( _instance == 0 ) _instance = new TextToolSelected();
      return _instance;
    }
    void handleClick( DrawTool * dt, int x1, int y1 );
    void handleHelp( void ) {
      // eLXg`c[̎gwvʂ\
    }
};
TextToolSelected * TextToolSelected::_instance = 0;

// }``c[\NX
class DrawTool {
    friend DTState;
    DTState * tState;
    void changeState( DTState * s ) { tState = s; }
  public :
    DrawTool( void ) : tState( NonSelected::instance() ) {}
    void doClick( int x1, int y1 ) { // }EXNbNs
      tState->handleClick( this, x1, y1 );
    }
    void doHelp( void ) { // wv@\Ăяo
      tState->handleHelp();
    }
};

void DTState::changeDTState( DrawTool * dt, DTState * s ) {
  dt->changeState( s );
}

void NonSelected::handleClick( DrawTool * dt, int x1, int y1 ) {
  if( /* NbNʒu``c[ACR */ ) {
    changeDTState( dt, RectToolSelected::instance() );
  }        
  else if( /* NbNʒueLXg`c[ACR */ ) {
    changeDTState( dt, TextToolSelected::instance() );
  }
}

void RectToolSelected::handleClick( DrawTool * dt, int x1, int y1 ) {
  do {} while( /* }EXNbNĂȂȂ^ */ );
  if( /* NbNʒuhLg̏ꍇ */ ) {
    // }EXNbN̈ʒux2y2Ɋi[C_(x1,y1)
    // `̂ЂƂ̊pC̊pƑΊp֌Wɂʂ̊p
    // _(x2, y2)ƂāC``悷
  }
  else if( /* NbNʒueLXg`c[ACR */ ) {
    changeDTState( dt, TextToolSelected::instance() );
  }
  else if( /* NbNŕ`c[IɂȂ邩 */ ) {
    changeDTState( dt, NonSelected::instance() );
  }
}

void TextToolSelected::handleClick( DrawTool * dt, int x1, int y1 ) {
  // eLXg̓tB[h𐶐
  do { /* eLXg͂s */ } 
    while( /* eLXgtB[hOł̃NbNł͂ȂȂ^ */ );
  // eLXg͏I
  if( /* NbNʒu``c[ACR */ ) {
    changeDTState( dt, RectToolSelected::instance() );
  }        
  else if( /* NbNŕ`c[IɂȂ邩 */ ) {
    changeDTState( dt, NonSelected::instance() );
  }
}