package java.util;

// ObserverパターンのSubjectに相当
public class Observable {
  // publicなメソッド
  public Observable();
  public synchronized void addObserver( Observer o );
  public synchronized void deleteObserver ( Observer o );
  public synchronized void deleteObservers();
  public synchronized int countObservers();
  public void notifyObservers();
  public void notifyObservers( Object arg );
  protected synchronized void setChanged();
  protected synchronized void clearChanged();
  public synchronized boolean hasChanged();
}