#include <string>
#include <vector>
#include <iostream>
using namespace std;

class TextDocument;
class TextDocumentCaretaker;

class TextDocumentMemento { // Mementoɑ
  friend TextDocument;      // TextDocumentfriendɎw肷
  string state;             // 
  TextDocumentMemento( const string & str ) : state( str ) {}
  string getState( void ) { return state; }
};

class TextDocumentCaretaker { // Caretakerɑ
    vector<TextDocumentMemento *> mementos;
  public :
    TextDocumentMemento * popMemento( void ) {
      if( mementos.empty() ) return 0;
      TextDocumentMemento * m = mementos.back();
      mementos.pop_back();
      return m;
    }
    void pushMemento( TextDocumentMemento * m ) {
      if( m != 0 ) mementos.push_back( m );
    }
};

class TextDocument { // ރIuWFNg // Originatorɑ
    string state;    // 
    TextDocumentCaretaker caretaker; // ނCaretaker
  public :
    TextDocument( void ) : state( "" ) {}
    void createMemento( void ) {
      caretaker.pushMemento( new TextDocumentMemento( state ) );
    }
    void setMemento( void ) {
      TextDocumentMemento * m = caretaker.popMemento();
      if( m != 0 ) state = m->getState();
      delete m;
    }
    string getData( void ) { return state; }
    void setData( const string & str ) { state = str; }
    void print( void ) { cout << state << endl; }
};


int main( void )
{
  TextDocument td1;
  td1.setData( "abc" ); td1.createMemento(); // 0 "abc"
  td1.setData( "123" ); td1.createMemento(); // 1 "123"
  td1.setData( "***" );                      // 2 "***"
  td1.setMemento(); td1.print();             // 1ɕA
  td1.setMemento(); td1.print();             // 0ɕA
  return 0;
}